/*** Generated by streamline 0.10.17 (callbacks) - DO NOT EDIT ***/ "use strict"; var __rt=require('streamline/lib/callbacks/runtime').runtime(__filename, false),__func=__rt.__func,__cb=__rt.__cb,__catch=__rt.__catch,__tryCatch=__rt.__tryCatch; var generatorUtils = require("../../../util/generatorUtils");






















var resourceUtils = require("../resource/resourceUtils");
var util = require("util");
var validation = require("../../../util/validation");

var profile = require("../../../util/profile");
var utils = require("../../../util/utils");

var $ = utils.getLocaleString;

exports.init = function(cli) {
  var network = cli.category("network").description($("Commands to manage network resources"));

  var loadBalancers = network.category("lb").description($("Commands to manage load balancers"));

  var probes = loadBalancers.category("probe").description($("Commands to manage probes"));


  var protocolTCP = "TCP";
  var defaultProtocol = "TCP";
  var defaultPort = "80";

  probes.command("create [resource-group] [lb-name] [name]").description($("Create a probes")).usage("[options] <resource-group> <lb-name> <name>").option("-g, --resource-group <resource-group>", $("the name of the resource group")).option("-l, --lb-name <lb-name>", $("the lb name")).option("-n, --name <name>", $("the name of the probe")).option("-p, --protocol [protocol]", $(((("the protocol of the end point. Possible" + "\n     values are: 'Http' or 'Tcp'. If 'Tcp' is specified, a received ACK is") + "\n     required for the probe to be successful. If 'Http' is specified, a 200 OK") + "\n     response from the specifies URI is required for the probe to be successful"))).option("-o, --port [port]", $(("the port for communicating the probe." + "\n     Possible values range from 1 to 65535, inclusive"))).option("-i, --interval [interval]", $((((("the interval, in seconds, for how" + "\n     frequently to probe the endpoint for health status. Typically, the interval is") + "\n     slightly less than half the allocated timeout period (in seconds) which allows") + "\n     two full probes before taking the instance out of rotation. The default value") + "\n     is 15, the minimum value is 5"))).option("-c, --count [count]", $(((("the number of probes where if no" + "\n     response, will result in stopping further traffic from being delivered to the") + "\n     endpoint. This values allows endpoints to be taken out of rotation faster or") + "\n     slower than the typical times used in Azure"))).option("-f, --path [path]", $((("the URI used for requesting health" + "\n     status from the VM. Path is required if a protocol is set to http. Otherwise,") + "\n     it is not allowed. There is no default value"))).option("-s, --subscription <subscription>", $("the subscription identifier")).execute(function __1(resourceGroup, lbName, name, options, _) { var useDefaults, subscription, networkManagementClient, index, loadBalancer, progress, parameters; var __frame = { name: "__1", line: 70 }; return __func(_, this, arguments, __1, 4, __frame, function __$__1() {

























      useDefaults = true;
      return cli.interaction.promptIfNotGiven($("resource group : "), resourceGroup, __cb(_, __frame, 2, 38, function ___(__0, __1) { resourceGroup = __1;
        return cli.interaction.promptIfNotGiven($("lb name : "), lbName, __cb(_, __frame, 3, 31, function ___(__0, __2) { lbName = __2;
          return cli.interaction.promptIfNotGiven($("name : "), name, __cb(_, __frame, 4, 29, function ___(__0, __3) { name = __3;

            subscription = profile.current.getSubscription(options.subscription);
            networkManagementClient = utils.createNetworkManagementClient(subscription);

            index = 0;

            progress = cli.interaction.progress(util.format($("Looking up the load balancer \"%s\""), lbName)); return (function ___(__then) { (function ___(_) { __tryCatch(_, function __$__1() { return (function ___(__then) { (function ___(_) { __tryCatch(_, function __$__1() {

                        return networkManagementClient.loadBalancers.get(resourceGroup, lbName, null, __cb(_, __frame, 13, 61, function ___(__0, __4) { loadBalancer = __4; __then(); }, true)); }); })(function ___(e, __result) { __catch(function __$__1() { if (e) {

                          if ((e.statusCode === 404)) {
                            loadBalancer = null; }
                           else {
                            return _(e); } ; __then(); } else { _(null, __result); } ; }, _); }); })(function ___() { __tryCatch(_, function __$__1() { _(null, null, true); }); }); }); })(function ___(__e, __r, __cont) { (function ___(__then) { __tryCatch(_, function __$__1() {


                    progress.end(); __then(); }); })(function ___() { __tryCatch(_, function ___() { if (__cont) { __then(); } else { _(__e, __r); }; }); }); }); })(function ___() { __tryCatch(_, function __$__1() {


                if (!loadBalancer) {
                  return _(new Error(util.format($("load balancer with name \"%s\" not found in the resource group \"%s\""), lbName, resourceGroup))); } ;


                if (utils.findFirstCaseIgnore(loadBalancer.probes, { name: name })) {
                  return _(new Error(util.format($("probes with name \"%s\" already exists in the \"%s\""), name, lbName))); } ;


                parameters = { };
                if (!parameters.probes) {
                  parameters.probes = []; } ;

                if (!parameters.probes[index]) {
                  parameters.probes[index] = { }; } ;

                if (options.protocol) {
                  parameters.probes[index].protocol = validation.isIn(options.protocol, ["Http","Tcp",], "--protocol");
                  if ((options.protocol.toLowerCase() == protocolTCP.toLowerCase())) {
                    delete parameters.probes[index].requestPath; } ; } else {

                  if (useDefaults) {
                    parameters.probes[index].protocol = defaultProtocol; } ; } ;


                if (options.port) {
                  parameters.probes[index].port = parseInt(options.port, 10); } else {
                  if (useDefaults) {
                    parameters.probes[index].port = parseInt(defaultPort, 10); } ; } ;


                if (options.interval) {
                  parameters.probes[index].intervalInSeconds = parseInt(options.interval, 10); } ;


                if (options.count) {
                  parameters.probes[index].numberOfProbes = parseInt(options.count, 10); } ;


                if (options.path) {
                  parameters.probes[index].requestPath = options.path; } ;


                parameters.probes[index].name = name;
                loadBalancer.probes.push(parameters.probes[index]);

                generatorUtils.removeEmptyObjects(parameters);
                progress = cli.interaction.progress(util.format($("Creating probes in \"%s\""), lbName)); return (function ___(__then) { (function ___(_) { __tryCatch(_, function __$__1() {

                      return networkManagementClient.loadBalancers.createOrUpdate(resourceGroup, lbName, loadBalancer, __cb(_, __frame, 72, 61, function ___(__0, __5) { loadBalancer = __5; _(null, null, true); }, true)); }); })(function ___(__e, __r, __cont) { (function ___(__then) { __tryCatch(_, function __$__1() {

                        progress.end(); __then(); }); })(function ___() { __tryCatch(_, function ___() { if (__cont) { __then(); } else { _(__e, __r); }; }); }); }); })(function ___() { __tryCatch(_, function __$__1() {


                    cli.interaction.formatOutput(loadBalancer.probes[generatorUtils.findIndexByKeyValue(loadBalancer.probes, "name", name)], generatorUtils.traverse); _(); }); }); }); }); }, true)); }, true)); }, true)); }); });


  probes.command("set [resource-group] [lb-name] [name]").description($("Update a probes")).usage("[options] <resource-group> <lb-name> <name>").option("-g, --resource-group <resource-group>", $("the name of the resource group")).option("-l, --lb-name <lb-name>", $("the lb name")).option("-n, --name <name>", $("the name of the probe")).option("-p, --protocol [protocol]", $(((("the protocol of the end point. Possible" + "\n     values are: 'Http' or 'Tcp'. If 'Tcp' is specified, a received ACK is") + "\n     required for the probe to be successful. If 'Http' is specified, a 200 OK") + "\n     response from the specifies URI is required for the probe to be successful"))).option("-o, --port [port]", $(("the port for communicating the probe." + "\n     Possible values range from 1 to 65535, inclusive"))).option("-i, --interval [interval]", $((((("the interval, in seconds, for how" + "\n     frequently to probe the endpoint for health status. Typically, the interval is") + "\n     slightly less than half the allocated timeout period (in seconds) which allows") + "\n     two full probes before taking the instance out of rotation. The default value") + "\n     is 15, the minimum value is 5"))).option("-c, --count [count]", $(((("the number of probes where if no" + "\n     response, will result in stopping further traffic from being delivered to the") + "\n     endpoint. This values allows endpoints to be taken out of rotation faster or") + "\n     slower than the typical times used in Azure"))).option("-f, --path [path]", $((("the URI used for requesting health" + "\n     status from the VM. Path is required if a protocol is set to http. Otherwise,") + "\n     it is not allowed. There is no default value"))).option("-s, --subscription <subscription>", $("the subscription identifier")).execute(function __2(resourceGroup, lbName, name, options, _) { var useDefaults, subscription, networkManagementClient, loadBalancer, progress, probe, index, parameters; var __frame = { name: "__2", line: 175 }; return __func(_, this, arguments, __2, 4, __frame, function __$__2() {

























      useDefaults = false;
      return cli.interaction.promptIfNotGiven($("resource group : "), resourceGroup, __cb(_, __frame, 2, 38, function ___(__0, __1) { resourceGroup = __1;
        return cli.interaction.promptIfNotGiven($("lb name : "), lbName, __cb(_, __frame, 3, 31, function ___(__0, __2) { lbName = __2;
          return cli.interaction.promptIfNotGiven($("name : "), name, __cb(_, __frame, 4, 29, function ___(__0, __3) { name = __3;

            subscription = profile.current.getSubscription(options.subscription);
            networkManagementClient = utils.createNetworkManagementClient(subscription);


            progress = cli.interaction.progress(util.format($("Looking up the load balancer \"%s\""), lbName)); return (function ___(__then) { (function ___(_) { __tryCatch(_, function __$__2() { return (function ___(__then) { (function ___(_) { __tryCatch(_, function __$__2() {

                        return networkManagementClient.loadBalancers.get(resourceGroup, lbName, null, __cb(_, __frame, 12, 61, function ___(__0, __4) { loadBalancer = __4; __then(); }, true)); }); })(function ___(e, __result) { __catch(function __$__2() { if (e) {

                          if ((e.statusCode === 404)) {
                            loadBalancer = null; }
                           else {
                            return _(e); } ; __then(); } else { _(null, __result); } ; }, _); }); })(function ___() { __tryCatch(_, function __$__2() { _(null, null, true); }); }); }); })(function ___(__e, __r, __cont) { (function ___(__then) { __tryCatch(_, function __$__2() {


                    progress.end(); __then(); }); })(function ___() { __tryCatch(_, function ___() { if (__cont) { __then(); } else { _(__e, __r); }; }); }); }); })(function ___() { __tryCatch(_, function __$__2() {


                if (!loadBalancer) {
                  return _(new Error(util.format($("load balancer with name \"%s\" not found in the resource group \"%s\""), lbName, resourceGroup))); } ;


                probe = utils.findFirstCaseIgnore(loadBalancer.probes, { name: name });
                index = utils.indexOfCaseIgnore(loadBalancer.probes, { name: name });
                if (!probe) {
                  return _(new Error(util.format($("probes with name \"%s\" not found in the \"%s\""), name, lbName))); } ;


                parameters = loadBalancer;
                if (!parameters.probes) {
                  parameters.probes = []; } ;

                if (!parameters.probes[index]) {
                  parameters.probes[index] = { }; } ;

                if (options.protocol) {
                  parameters.probes[index].protocol = validation.isIn(options.protocol, ["Http","Tcp",], "--protocol");
                  if ((options.protocol.toLowerCase() == protocolTCP.toLowerCase())) {
                    delete parameters.probes[index].requestPath; } ; } else {

                  if (useDefaults) {
                    parameters.probes[index].protocol = defaultProtocol; } ; } ;


                if (options.port) {
                  parameters.probes[index].port = parseInt(options.port, 10); } else {
                  if (useDefaults) {
                    parameters.probes[index].port = parseInt(defaultPort, 10); } ; } ;


                if (options.interval) {
                  parameters.probes[index].intervalInSeconds = parseInt(options.interval, 10); } ;


                if (options.count) {
                  parameters.probes[index].numberOfProbes = parseInt(options.count, 10); } ;


                if (options.path) {
                  parameters.probes[index].requestPath = options.path; } ;


                generatorUtils.removeEmptyObjects(parameters);
                progress = cli.interaction.progress(util.format($("Updating probes in \"%s\""), lbName)); return (function ___(__then) { (function ___(_) { __tryCatch(_, function __$__2() {

                      return networkManagementClient.loadBalancers.createOrUpdate(resourceGroup, lbName, loadBalancer, __cb(_, __frame, 70, 61, function ___(__0, __5) { loadBalancer = __5; _(null, null, true); }, true)); }); })(function ___(__e, __r, __cont) { (function ___(__then) { __tryCatch(_, function __$__2() {

                        progress.end(); __then(); }); })(function ___() { __tryCatch(_, function ___() { if (__cont) { __then(); } else { _(__e, __r); }; }); }); }); })(function ___() { __tryCatch(_, function __$__2() {

                    cli.interaction.formatOutput(loadBalancer.probes[index], generatorUtils.traverse); _(); }); }); }); }); }, true)); }, true)); }, true)); }); });


  probes.command("delete [resource-group] [lb-name] [name]").description($("Delete a probes")).usage("[options] <resource-group> <lb-name> <name>").option("-g, --resource-group <resource-group>", $("the name of the resource group")).option("-l, --lb-name <lb-name>", $("the lb name")).option("-n, --name <name>", $("the name of the probe")).option("-q, --quiet", $("quiet mode, do not ask for delete confirmation")).option("-s, --subscription <subscription>", $("the subscription identifier")).execute(function __3(resourceGroup, lbName, name, options, _) { var subscription, networkManagementClient, loadBalancer, progress, index; var __frame = { name: "__3", line: 260 }; return __func(_, this, arguments, __3, 4, __frame, function __$__3() {








      return cli.interaction.promptIfNotGiven($("resource group : "), resourceGroup, __cb(_, __frame, 1, 38, function ___(__0, __2) { resourceGroup = __2;
        return cli.interaction.promptIfNotGiven($("lb name : "), lbName, __cb(_, __frame, 2, 31, function ___(__0, __3) { lbName = __3;
          return cli.interaction.promptIfNotGiven($("name : "), name, __cb(_, __frame, 3, 29, function ___(__0, __4) { name = __4;

            subscription = profile.current.getSubscription(options.subscription);
            networkManagementClient = utils.createNetworkManagementClient(subscription);


            progress = cli.interaction.progress(util.format($("Looking up the load balancer \"%s\""), lbName)); return (function ___(__then) { (function ___(_) { __tryCatch(_, function __$__3() { return (function ___(__then) { (function ___(_) { __tryCatch(_, function __$__3() {

                        return networkManagementClient.loadBalancers.get(resourceGroup, lbName, null, __cb(_, __frame, 11, 61, function ___(__0, __5) { loadBalancer = __5; __then(); }, true)); }); })(function ___(e, __result) { __catch(function __$__3() { if (e) {

                          if ((e.statusCode === 404)) {
                            loadBalancer = null; }
                           else {
                            return _(e); } ; __then(); } else { _(null, __result); } ; }, _); }); })(function ___() { __tryCatch(_, function __$__3() { _(null, null, true); }); }); }); })(function ___(__e, __r, __cont) { (function ___(__then) { __tryCatch(_, function __$__3() {


                    progress.end(); __then(); }); })(function ___() { __tryCatch(_, function ___() { if (__cont) { __then(); } else { _(__e, __r); }; }); }); }); })(function ___() { __tryCatch(_, function __$__3() {


                if (!loadBalancer) {
                  return _(new Error(util.format($("load balancer \"%s\" not found in the resource group \"%s\""), lbName, resourceGroup))); } ;


                index = utils.indexOfCaseIgnore(loadBalancer.probes, { name: name });
                if ((index === -1)) {
                  return _(new Error(util.format($("probes \"%s\" not found in the lbName \"%s\""), name, loadBalancer.name))); } ; return (function __$__3(_) {


                  var __1 = !options.quiet; if (!__1) { return _(null, __1); } ; return cli.interaction.confirm(util.format($("Delete probes with name \"%s\" from \"%s\"? [y/n] "), name, lbName), __cb(_, __frame, 31, 45, function ___(__0, __3) { var __2 = !__3; return _(null, __2); }, true)); })(__cb(_, __frame, -259, 17, function ___(__0, __6) { return (function __$__3(__then) { if (__6) { return _(null); } else { __then(); } ; })(function __$__3() {



                    loadBalancer.probes.splice(index, 1);
                    progress = cli.interaction.progress("Deleting probes"); return (function ___(__then) { (function ___(_) { __tryCatch(_, function __$__3() {

                          return networkManagementClient.loadBalancers.createOrUpdate(resourceGroup, lbName, loadBalancer, __cb(_, __frame, 38, 61, function ___(__0, __7) { loadBalancer = __7; _(null, null, true); }, true)); }); })(function ___(__e, __r, __cont) { (function ___(__then) { __tryCatch(_, function __$__3() {

                            progress.end(); __then(); }); })(function ___() { __tryCatch(_, function ___() { if (__cont) { __then(); } else { _(__e, __r); }; }); }); }); })(function ___() { __tryCatch(_, function __$__3() { _(); }); }); }); }, true)); }); }); }, true)); }, true)); }, true)); }); });



  probes.command("show [resource-group] [lb-name] [name]").description($("Show a probes")).usage("[options] <resource-group> <lb-name> <name>").option("-g, --resource-group <resource-group>", $("the name of the resource group")).option("-l, --lb-name <lb-name>", $("the lb name")).option("-n, --name <name>", $("the name of the probe")).option("-s, --subscription <subscription>", $("the subscription identifier")).execute(function __4(resourceGroup, lbName, name, options, _) { var subscription, networkManagementClient, loadBalancer, progress, probe; var __frame = { name: "__4", line: 311 }; return __func(_, this, arguments, __4, 4, __frame, function __$__4() {







      return cli.interaction.promptIfNotGiven($("resource group : "), resourceGroup, __cb(_, __frame, 1, 38, function ___(__0, __1) { resourceGroup = __1;
        return cli.interaction.promptIfNotGiven($("lb name : "), lbName, __cb(_, __frame, 2, 31, function ___(__0, __2) { lbName = __2;
          return cli.interaction.promptIfNotGiven($("name : "), name, __cb(_, __frame, 3, 29, function ___(__0, __3) { name = __3;

            subscription = profile.current.getSubscription(options.subscription);
            networkManagementClient = utils.createNetworkManagementClient(subscription);


            progress = cli.interaction.progress(util.format($("Looking up the load balancer \"%s\""), lbName)); return (function ___(__then) { (function ___(_) { __tryCatch(_, function __$__4() { return (function ___(__then) { (function ___(_) { __tryCatch(_, function __$__4() {

                        return networkManagementClient.loadBalancers.get(resourceGroup, lbName, null, __cb(_, __frame, 11, 61, function ___(__0, __4) { loadBalancer = __4; __then(); }, true)); }); })(function ___(e, __result) { __catch(function __$__4() { if (e) {

                          if ((e.statusCode === 404)) {
                            loadBalancer = null; }
                           else {
                            return _(e); } ; __then(); } else { _(null, __result); } ; }, _); }); })(function ___() { __tryCatch(_, function __$__4() { _(null, null, true); }); }); }); })(function ___(__e, __r, __cont) { (function ___(__then) { __tryCatch(_, function __$__4() {


                    progress.end(); __then(); }); })(function ___() { __tryCatch(_, function ___() { if (__cont) { __then(); } else { _(__e, __r); }; }); }); }); })(function ___() { __tryCatch(_, function __$__4() {


                if (!loadBalancer) {
                  return _(new Error(util.format($("load balancer with name \"%s\" not found in the resource group \"%s\""), lbName, resourceGroup))); } ;


                probe = utils.findFirstCaseIgnore(loadBalancer.probes, { name: name });
                if (!probe) {
                  cli.output.warn(util.format($("probes with name \"%s\" not found in the lbName \"%s\""), name, loadBalancer.name)); } ;


                cli.interaction.formatOutput(probe, generatorUtils.traverse); _(); }); }); }, true)); }, true)); }, true)); }); });


  probes.command("list [resource-group] [lb-name]").description($("List probes")).usage("[options] <resource-group> <lb-name>").option("-g, --resource-group <resource-group>", $("the name of the resource group")).option("-l, --lb-name <lb-name>", $("the lb name")).option("-s, --subscription <subscription>", $("the subscription identifier")).execute(function __5(resourceGroup, lbName, options, _) { var subscription, networkManagementClient, loadBalancer, progress, items; var __frame = { name: "__5", line: 351 }; return __func(_, this, arguments, __5, 3, __frame, function __$__5() {






      subscription = profile.current.getSubscription(options.subscription);
      networkManagementClient = utils.createNetworkManagementClient(subscription);

      loadBalancer = null;
      progress = cli.interaction.progress(util.format($("Looking up the load balancer \"%s\""), lbName)); return (function ___(__then) { (function ___(_) { __tryCatch(_, function __$__5() { return (function ___(__then) { (function ___(_) { __tryCatch(_, function __$__5() {

                  return networkManagementClient.loadBalancers.get(resourceGroup, lbName, null, __cb(_, __frame, 7, 61, function ___(__0, __1) { loadBalancer = __1; __then(); }, true)); }); })(function ___(e, __result) { __catch(function __$__5() { if (e) {

                    if ((e.statusCode === 404)) {
                      loadBalancer = null; }
                     else {
                      return _(e); } ; __then(); } else { _(null, __result); } ; }, _); }); })(function ___() { __tryCatch(_, function __$__5() { _(null, null, true); }); }); }); })(function ___(__e, __r, __cont) { (function ___(__then) { __tryCatch(_, function __$__5() {


              progress.end(); __then(); }); })(function ___() { __tryCatch(_, function ___() { if (__cont) { __then(); } else { _(__e, __r); }; }); }); }); })(function ___() { __tryCatch(_, function __$__5() {


          if (!loadBalancer) {
            return _(new Error(util.format($("load balancers with name \"%s\" not found in the resource group \"%s\""), lbName, resourceGroup))); } ;


          items = loadBalancer.probes;
          cli.interaction.formatOutput(items, function(items) {
            if ((items.length === 0)) {
              cli.output.warn($("No probes found")); }
             else {
              cli.output.table(items, function(row, item) {
                row.cell($("Name"), item.name);
                var resInfo = resourceUtils.getResourceInformation(item.id);
                row.cell($("Resource group"), resInfo.resourceGroup);
                row.cell($("Provisioning state"), item.provisioningState); }); } ; }); _(); }); }); }); });};
